# From https://docs.gitlab.com/ce/ci/caching/#caching-nodejs-dependencies

image: node:14

cache:
  paths:
    - .npm/

before_script:
  - npm ci --cache .npm --prefer-offline
  - npm install netlify-cli

deploy_prod:
  stage: deploy
  only:
    refs:
      - master
  script:
    - cp .env.example .env
    - npm run build
    - cd scripts/netlify
    - npm run build:netlify
    - ../../node_modules/.bin/netlify deploy --dir=public --site $NETLIFY_SITE_ID --auth $NETLIFY_AUTH_TOKEN --prod
  environment:
    name: production
    url: https://toutafrique-beta.jailbreak.paris/

deploy_review:
  stage: deploy
  only:
    - branches
  except:
    - master
  script:
    - cp .env.example .env
    - npm run build
    - cd scripts/netlify
    - npm run build:netlify
    - ../../node_modules/.bin/netlify deploy --dir=public --site $NETLIFY_SITE_ID --auth $NETLIFY_AUTH_TOKEN --json > deploy-data.json
    - DEPLOY_URL=$(node -p "require('./deploy-data.json').deploy_url")
    - echo "DEPLOY_URL=$DEPLOY_URL" > $CI_PROJECT_DIR/deploy.env
    - echo Website draft URL is $DEPLOY_URL
  artifacts:
    reports:
      dotenv: deploy.env
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: $DEPLOY_URL
